Subject: Re: Last Call: 'Domain Name System (DNS) Case Insensitivity Clarification' to Proposed Standard

From: Edward Lewis <[email-masked]>
Date: Tue, 8 Feb 2005 11:33:51 -0500

At 14:33 +0100 2/8/05, Peter Koch wrote:

>RFC 2396 has recently been obsoleted by RFC 3986. That now uses a Thingy
>Formerly Known As Hostname.

Thanks.  (I wish they'd note "obsoleted-by" on the older RFCs. 
Googling often misses the new ones.)

The updated text isn't materially different than the old, although 
it's a lot more specific, "section 3.5" instead of just 3.  Getting 
into document lawyering (i.e., career preservation), I'm more 
convinced that \DDD isn't intended to be legal URI syntax.

Looking at this, which is the comment that is prolonging the thread...

At 7:11 +0000 2/7/05, D. J. Bernstein wrote:
>This document specifies \065 as a synonym for capital A---not just in
>zone files, but in all ``human readable and writable ASCII contexts.''
>
>That specification is plainly erroneous. Nobody is willing to defend the
>notion that this screwy decimal system should be allowed in URLs, SMTP
>RCPT, etc.
>
>The obvious fix is to limit the document to zone files.

Here is the text in the document:

# 2.1 Escaping Unusual DNS Label Octets
#
#    In Master Files [STD 13] and other human readable and writable ASCII
#    contexts, an escape is needed for the byte value for period (0x2E,

Note that the draft does not say "all" but rather "and other."  I 
don't see a need to edit this.  It's not an exclusive statement.

-- 
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
Edward Lewis                                                +1-571-434-5468
NeuStar

"A noble spirit embiggens the smallest man." - Jebediah Springfield

--
to unsubscribe send a message to [email-masked] with
the word 'unsubscribe' in a single line as the message text body.
archive: <http://ops.ietf.org/lists/namedroppers/>

---

From: Mark Andrews <[email-masked]>
Date: Wed, 09 Feb 2005 07:52:34 +1100

> Mark Andrews <[email-masked]> wrote:
> 
> {IESG removed from Cc}
> 
> > 	I stand by my words.  URLs take hostnames.  RFC 2396 just
> > 	described the subset of hostnames that are representable in
> > 	the DNS.
> 
> > 	names.  Most applications, including web browsers, take
> > 	hostnames.  The fact that you can represent most (but not all)
> > 	hostnames in the DNS just adds to the confusion.
> > 
> > 	Hostnames of length 254 and 255 cannot be represented in the DNS.
> 
> Yes, but "domain names" of length 254 or 255 cannot either - due to the fact
> that the wire format needs two more octets than the FQDN text representation.

	The length of domain names has always been defined in terms of the
	uncompressed wire length.  The presentation format can go to 1004
	characters.
 
> > 	I don't expect a application that takes a hostname to accept
> > 	\DDD.  I do expect a application that takes a domain name to
> > 	accept \DDD.
> 
> Now it may be time to dig out your long since expired Internet Draft again ..
> .
> 
> > 	Telnet, ssh, ftp etc. take hostnames.
> 
> Weird enough they should use IDNs - at a different layer, though.

	What this document is talking about is the DNS (that big replicated
	distributed database) and how you represent domain names in
	it.  In the tools that manipulate it.

	It has NOTHING to do with how hostnames are represented.
	The fact that you can store and retrieve hostnames from it
	is irrelevent as it is at a totally different layer.

	IDN exist at a layer about the DNS.  They are transformed to
	and from DNS labels.

--
Mark Andrews, ISC
1 Seymour St., Dundas Valley, NSW 2117, Australia
PHONE: +61 2 9871 4742                 INTERNET: [email-masked]

---

From: Danny Mayer <[email-masked]>
Date: Tue, 08 Feb 2005 21:50:56 -0500

At 11:33 AM 2/8/2005, Edward Lewis wrote:
>Thanks.  (I wish they'd note "obsoleted-by" on the older RFCs. Googling 
>often misses the new ones.)
>
>The updated text isn't materially different than the old, although it's a 
>lot more specific, "section 3.5" instead of just 3.  Getting into document 
>lawyering (i.e., career preservation), I'm more convinced that \DDD isn't 
>intended to be legal URI syntax.

URI's are described in RFC 1808 Section 2.1 and 1738 Section 3.1 which
describes the host part of the URI this way:

     host
         The fully qualified domain name of a network host, or its IP
         address as a set of four decimal digit groups separated by
         ".". Fully qualified domain names take the form as described
         in Section 3.5 of RFC 1034 [13] and Section 2.1 of RFC 1123
         [5]: a sequence of domain labels separated by ".", each domain
         label starting and ending with an alphanumerical character and
         possibly also containing "-" characters. The rightmost domain
         label will never start with a digit, though, which
         syntactically distinguishes all domain names from the IP
         addresses.

I happened to have grabbed it today to deal with another unrelated
matter.

Looks like escaped digits are not allowed in host names and domain
names. There's nothing in either Section 3.5 of RFC 1034 or Section 2.1
that mentions it.

Does that clarify things?

Danny

---

From: Alex Bligh <[email-masked]>
Date: Wed, 09 Feb 2005 10:36:39 +0000

> Does that clarify things?

Not really as going back to the previous question, that leaves domain
names having case "in them", but being compared case insensitively for
DNS applications, but (unless it's elsewhere) no such prescription on
the host part of URI's. I think all you've shown is that DJB's
"typing things into browser bar"'s example is insufficient to prove
his point, as the escape sequence itself may have been (correctly)
passed in the wire-format URI rather than the capital letter he (I think)
intended.

Alex

---

From: Danny Mayer <[email-masked]>
Date: Wed, 09 Feb 2005 22:01:18 -0500

>passed in the wire-format URI rather than the capital letter he (I think)

I agree, but then you didn't need my reference for this observation as it
has nothing to do with DNS, just with browsers and perhaps http servers.

Danny